#!/usr/bin/ruby -Ke
require 'net/smtp'
require 'kconv'

REPOS=ARGV[0]
REV=ARGV[1].to_i
TRAC_PROJECTNAME='vod'
TRAC_URL='http://example.com/projects/'+TRAC_PROJECTNAME+'/'
MAIL_TO=['vod-gl@example.com']
MAIL_FROM=['svn@example.com']

svnauthor=%x{svnlook author #{REPOS} -r #{REV}}.chomp
svndate=%x{svnlook date #{REPOS} -r #{REV}}.chomp
svnchanged=%x{svnlook changed #{REPOS} -r #{REV}}.chomp
svnlog=%x{svnlook log #{REPOS} -r #{REV}}.chomp
svndiff=%x{svnlook diff #{REPOS} -r #{REV}}.chomp

body = <<END_OF_BODY
Subversion committed to #{REPOS} #{REV}

  : #{svnauthor.ljust(46)}
: #{svndate.ljust(46)}


#{TRAC_URL}changeset/#{REV}

Log:
--------------------------------------------------------
#{svnlog}

Changed:                      [U:A:ɲáD:]
--------------------------------------------------------
#{svnchanged}

Diff:
--------------------------------------------------------
#{svndiff}

END_OF_BODY

message = <<END_OF_MESSAGE
From: Subversion Admin <#{MAIL_FROM}>
To: Subversion committers:;
Subject: [#{REPOS}] r#{REV} commit
MIME-Version: 1.0
Content-Type: text/plain; charset = ISO-2022-JP
X-Mailer: Subversion email-send.rb

#{body.tojis}
END_OF_MESSAGE

Net::SMTP.start('localhost', 25) { |smtp|
    smtp.send_mail(message, MAIL_FROM, *MAIL_TO)
}

